//Design : ѽ¹
//ѹα Ͽ...
package jspFrameWork.control;

import javax.servlet.*;
import javax.servlet.http.*;
import jspFrameWork.model.*;
import jspFrameWork.view.*;
import jspFrameWork.control.*;
import jspFrameWork.exception.*;
import jspFrameWork.dbframe.*;
import jspFrameWork.util.*;


public abstract class ControlSwitch implements IControlSwitch
{
	ParamMap paramMap;
	Persistent persistent;
	
	public void turnOn(HttpServletRequest req, HttpServletResponse res)throws ServletException, java.io.IOException
	{
		persistent = EntityFactory.getPersistent(paramMap);
		p.r(this,"persistent",persistent);
		doAction();
		Presentation presentation = Presentation.getPresentation(paramMap);
		req.setAttribute("persistent",persistent);
		String base = req.getContextPath();
		p.r(this,"base - controlswitch" , base);
		String page = presentation.getPage();			
		p.r(this,"page" , page);
		String forwardingPage = "/jsp/" + page;
//		String forwardingPage = base + "/jsp/" + page;
		p.r(this,"forwardingPage-3rd" , forwardingPage);
		RequestDispatcher reqDispatcher = req.getRequestDispatcher(forwardingPage);
		p.r(this,"requestDispatcher" , reqDispatcher);
		reqDispatcher.forward(req,res);
	}
		
	public void reset(ParamMap paramMap)
	{
		this.paramMap = paramMap;	
	}
	
	public abstract void doAction();

	public void destroy()
	{
		paramMap = null;
		persistent = null;	
	}
}

