package jspFrameWork.view;

import java.lang.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import jspFrameWork.control.*;
import jspFrameWork.view.*;
import jspFrameWork.model.*;
import jspFrameWork.dbframe.*;
import jspFrameWork.exception.*;
import jspFrameWork.util.*;


public class GateServlet extends HttpServlet
{
/*
	public void init() throws ServletException
	{	
		Connection con = null;
		try
		{
			p.r(this,"dbcreation","getConnection");			
			con = DBConnectionManager.getInstance().getConnection("oracle");/////

			try
			{
				Thread.currentThread().sleep(10000);
			}
			catch(InterruptedException iE)
			{
				iE.printStackTrace();
			}
			
			p.r(this,"dbcreation","sleep -> wake");			
			
			p.r(this,"dbcreation","freeConnection");			
		    DBConnectionManager.getInstance().freeConnection("oracle", con);/////
			p.r(this,"dbcreation","db-init finished");			

		}
		catch(SQLException sqlE)
		{
			p.r(this,"dbinit error");
		}
		
		System.out.println(" Database initialized : " +con);
	}
*/	
	
	
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException
	{
		ParamMap paramMap;
		String protocol = null;
		String errorForwardPage = "Error.jsp";
		try
		{
			paramMap = new ParamMap(req);
			p.r("GateServlet" ,paramMap);
			p.r("GateServlet" ,"start");
			protocol = (String)paramMap.get("command");
			p.r("GateServlet" ,protocol);
			IControlSwitch controlSwitch = EntityFactory.getControlSwitch(paramMap);
			controlSwitch.turnOn(req,res);
		}
		catch(Exception e)
		{
			String base = req.getContextPath();
			//RequestDispatcher requestDispatcher = req.getRequestDispatcher(base + "/jsp/" + "ErrorTest.jsp");
			p.r(this,"base-getContextPath()" , base);
			int control = Integer.parseInt(protocol);
			p.r(this,"doAction-control",protocol);

			switch(control)
			{
				case Protocol.ADD :
					{
						errorForwardPage = "ClientError.jsp";
						break;
					}
					
				case Protocol.RETRIVE :
					{
						errorForwardPage = "OrderError.jsp";
						break;
					}
					
				case Protocol.DELETE :
					{
						errorForwardPage = "LogError.jsp";
						break;
					}
					
				case Protocol.PRINT :
					{
						errorForwardPage = "ArchiveError.jsp";
						break;
					}
					
			}
			RequestDispatcher requestDispatcher = req.getRequestDispatcher("/jsp/" + errorForwardPage);
//			RequestDispatcher requestDispatcher = req.getRequestDispatcher("/jsp/Error.jsp");
			requestDispatcher.forward(req,res);
		}
	}
	
	void forwardPage(HttpServletRequest req, HttpServletResponse res,String page) throws ServletException, IOException, Exception
	{
/*			Original servlet  ִ 		
			String page="/jsp/Test.jsp";
			RequestDispatcher dsp=req.getRequestDispatcher(
					req.getContextPath()+page);		
*/		
		
		
		String base = req.getContextPath();
		p.r(this,"base-getContextPath()" , base);
//		String forwardingPage = base + "/jsp/" + page;
		String forwardingPage = base + "/jsp/" + "Test.jsp";
		p.r(this,"base" , base);
		p.r(this,"page" , page);
		p.r(this,"forwardingPage-2nd" , forwardingPage);
		RequestDispatcher reqDispatcher = req.getRequestDispatcher(forwardingPage);
		p.r(this,"requestDispatcher" , reqDispatcher);
//		Thread.currentThread().sleep(10000);
		reqDispatcher.forward(req,res);
		
		
	}
	
}
