//Design : ѽ¹
//ѹα Ͽ...
package jspFrameWork.control;

import jspFrameWork.control.*;
import jspFrameWork.model.*;
import jspFrameWork.exception.*;
import jspFrameWork.dbframe.*;
import jspFrameWork.util.*;


public class EntityFactory
{
	private EntityFactory()
	{
	}

	
	public static IControlSwitch getControlSwitch(ParamMap paramMap)
	{
		p.r("getControlSwitch","paramMap",paramMap);
		String val = null;
		val = (String)paramMap.get("command");
		p.r("getControlSwitch-command" ,val);
		String protocol =(String)paramMap.get("control");
		p.r("EntityFactory1", "protocol",protocol);
		String command =(String)paramMap.get("command");
		p.r("EntityFactory2", "command",command);
		p.r("EntityFactory3", "protocol",protocol);
		int control = Integer.parseInt(protocol);
		p.r("EntityFactory4", "control",control);
		IControlSwitch controlSwitch = null;
		try
		{
			switch (control)
			{
				case Protocol.CLIENT :
						controlSwitch = new ClientControl();
						p.r("EntityFactory","ClientControl Ͽϴ.",controlSwitch);
						break;

				case Protocol.ORDER :
						controlSwitch = new ClientControl();// ϼ  
						p.r("EntityFactory","ClientControl Ͽϴ.",controlSwitch);
						break;
				case Protocol.LOG :
						controlSwitch = new ClientControl();// ϼ  
						p.r("EntityFactory","ClientControl Ͽϴ.",controlSwitch);
						break;

				case Protocol.ARCHIVE :
						controlSwitch = new ClientControl();// ϼ  
						p.r("EntityFactory","ClientControl Ͽϴ.",controlSwitch);
						break;

				default :
						throw new CodeException(" protocol   ֽϴ. ");
			}	
		}
		
		catch(Exception e)
		{
			p.r("EntityFactory",e);
			throw new CodeException(e);
		}
		controlSwitch.reset(paramMap);
		return controlSwitch;
	}
	
	public static Persistent getPersistent(ParamMap paramMap)
	{
		String protocol = (String)paramMap.get("control");
		p.r("EntityFactory", "protocol",protocol);
		int control = Integer.parseInt(protocol);
		p.r("EntityFactory", "control",control);
		
		Persistent persistent = null;
		try
		{
			switch (control)
			{
				case Protocol.CLIENT :
						persistent = new NotePersistent();
						p.r("EntityFactory","NotePersistent() Ͽϴ.",persistent);
						persistent.reset(paramMap);
						p.r("EntityFactory","Protocol.CLIENT",Protocol.CLIENT);
						break;
				case Protocol.ORDER :
						persistent = new NotePersistent();
						p.r("EntityFactory","NotePersistent() Ͽϴ.",persistent);
						persistent.setTerm(paramMap);
						p.r("EntityFactory","Protocol.ORDER",Protocol.ORDER);
						break;
				case Protocol.LOG :
						persistent = new NotePersistent();
						p.r("EntityFactory","NotePersistent() Ͽϴ.",persistent);
						persistent.setTerm(paramMap);
						p.r("EntityFactory","Protocol.LOG",Protocol.LOG);
						break;
				case Protocol.ARCHIVE :
						persistent = new NotePersistent();
						p.r("EntityFactory","NotePersistent() Ͽϴ.",persistent);
						persistent.setPrintTerm(paramMap);
						p.r("EntityFactory","Protocol.ORDER",Protocol.ARCHIVE);
						break;
				
				default :
						throw new CodeException(" protocol   ֽϴ. ");
			}	
		}
		
		catch(Exception e)
		{
			p.r("EntityFactory",e);
			throw new CodeException(e);
		}
		return persistent;
	}
}
