//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
package jspFrameWork.dbframe;

import java.io.*;
import java.util.*;
import jspFrameWork.control.*;
import jspFrameWork.exception.*;
import jspFrameWork.util.*;


public abstract class Persistent 
{
	public Vector tableV;	

	public boolean isNew()
	{
		tableV = getPersistentPeer().query();
		p.r(this,"isNew()",tableV.size());
		return (tableV.size() == 0 ? true : false );
	}

	public boolean save()
	{
		p.r(this,"insert","ok");
		return( isNew() ? getPersistentPeer().insert() : false) ;
	}

	public boolean remove()
	{
		p.r(this,"delete","ok");
		return (!isNew() ? getPersistentPeer().delete() : false);
	}

	public boolean modify()
	{
		p.r(this,"update","ok");
		return ( !isNew() ? getPersistentPeer().update() : false);
	}

	public boolean restore()
	{
		p.r(this,"restore","ok");
		return ( !isNew() ? struct(tableV) : false);
	}

	public Vector getNewTable()
	{	
		p.r(this,"getNewTable","ok");
		return ( !isNew() ? reStruct(tableV) : null);
	}

	public Vector getTable()
	{
		return tableV;
	}
	public String e2h(String en)
	{
		String han=null;
		if(en==null)throw new NullPointerException("Parameter is Null");
		try
		{
			han=new String(en.getBytes("ISO8859_1"),"euc-kr");
		}
		catch(UnsupportedEncodingException ue)
		{
			throw new CodeException(ue);
		}
		return han;
	}
	public String h2e(String han)
	{
		String en=null;
		if(han==null)throw new NullPointerException("Parameter is Null");
		try
		{
			en=new String(han.getBytes("euc-kr"),"ISO8859_1");
		}
		catch(UnsupportedEncodingException ue)
		{
			throw new CodeException(ue);
		}
		return en;
	}
	public abstract void print();
	public abstract Vector reStruct(Vector tableV);
	public abstract void setTerm(ParamMap paramMap);
	public abstract void setPrintTerm(ParamMap paramMap);
	public abstract void reset(ParamMap paramMap);
	public abstract boolean struct(Vector tableV);
	public abstract PersistentPeer getPersistentPeer();
	public abstract String getInsertSql();
	public abstract String getDeleteSql();
	public abstract String getUpdateSql();
	public abstract String getSelectSql();
} /* end class Persistent */
