//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
package jspFrameWork.model;
import java.util.*;
import jspFrameWork.dbframe.*;
import jspFrameWork.control.*;
import jspFrameWork.exception.*;
import jspFrameWork.util.*;

public class NotePersistent extends Persistent 
{
	PersistentPeer persistentPeer;
        String name;
        String phone;
        String mail;
        String major;
        String budyid;
        String selec;
        String na;
        String nb;
        String nc;
        String nd;
        String ne;
        String nf;
        String ng;
        String nh;
        String ni;
        String nj;
        String nk;
        String nl;
        String nm;
        String nn;
        String no;
        String np;
        String tot;
        String price;

	String COMMA = ",";
	String START = "(";
	String END = ")";

	String AND = " and ";
	String OR = " or ";
	String EQUAL = " = ";
	
	String query;
	String insertSql;
	String deleteSql;
	String updateSql;
	
	public NotePersistent(        String name,String phone,String mail,
									String major,String budyid,String selec,
									String NA,String NB,String NC,String ND,
									String NE,String NF,String NG,String NH,
									String NI,String NJ,String NK,String NL,
									String NM,String NN,String NO,String NP)
	{
		this.name = name;
		this.phone = phone;
		this.mail = mail;
		this.budyid = budyid;
		this.selec = selec;
		this.na = NA;
		this.nb = NB;
		this.nc = NC;
		this.nd = ND;
		this.ne = NE;
		this.nf = NF;
		this.ng = NG;
		this.nh = NH;
		this.ni = NI;
		this.nj = NJ;
		this.nk = NK;
		this.nl = NL;
		this.nm = NM;
		this.nn = NN;
		this.no = NO;
		this.np = NP;
		calcOrder();
		insertSql = "insert into NOTE(name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np) 		 values " + START +  makeStr(name)+COMMA +  makeStr(phone) + COMMA +  makeStr(mail) + COMMA +  makeStr(major) + COMMA +  makeStr(budyid) + COMMA +  makeStr(selec) + COMMA +  makeStr(NA) + COMMA +  makeStr(NB) + COMMA +  makeStr(NC) + COMMA +  makeStr(ND) + COMMA +  makeStr(NE) + COMMA +  makeStr(NF) + COMMA +  makeStr(NG) + COMMA +  makeStr(NH) + COMMA +  makeStr(NI) + COMMA +  makeStr(NJ) + COMMA +  makeStr(NK) + COMMA +  makeStr(NL) + COMMA +  makeStr(NM) + COMMA +  makeStr(NN) + COMMA +  makeStr(NO) + COMMA +  makeStr(NP) + COMMA +  makeStr(tot) + COMMA +  makeStr(price) + END;		
		setQuery("name", name, "budyidbudyid", budyid);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public NotePersistent(String name, String phone)
	{
		setQuery("name",name,"budyid",budyid);
		deleteSql = "delete from note where name " + EQUAL + makeStr(name) + AND +"phone" + EQUAL +makeStr(phone); 
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public NotePersistent()
	{
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	
  
/*
	void setPersistentPeer(PersistentPeer concreteDatabasePeer)
	{
		this.persistentPeer = concreteDatabasePeer;
	}
*/	

	void setQuery() 
	{
		query = "select name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price FROM note"; 
//		System.out.println("setQuery() : "+query);
	}
	
	
	void setQuery(String columnName,  String condition) 
	{
		query = "select name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price FROM note WHERE " + columnName + EQUAL + makeStr(condition); 
//		System.out.println("setQuery() : "+query);
	}

	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		query = "select name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price FROM note WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) ; 
//		System.out.println("setQuery() : "+query);
	}
	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3, String condition3) 
	{
		query = "select name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price note WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3) ; 
//		System.out.println("setQuery() : "+query);
	}

	void setDeleteSql(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		deleteSql = "delete from note where " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2); 
//		System.out.println("setDeleteSql() : "+ deleteSql);
	}

	void setInsertSql(String value1, String value2, String value3, String value4, String value5, String value6, String value7, String value8, String value9, String value10, String value11, String value12, String value13, String value14, String value15, String value16, String value17, String value18, String value19, String value20, String value21, String value22, String value23, String value24) 
	{
		insertSql = "insert into note (name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price ) values" + START + makeStr(value1) + COMMA + makeStr(value2) + COMMA + makeStr(value3) + COMMA + makeStr(value4) + COMMA + makeStr(value5) + COMMA + makeStr(value6) + COMMA + makeStr(value7) + COMMA + makeStr(value8) + COMMA + makeStr(value9) + COMMA + makeStr(value10) + COMMA + makeStr(value11) + COMMA + makeStr(value12) + COMMA + makeStr(value13) + COMMA + makeStr(value14) + COMMA + makeStr(value15) + COMMA + makeStr(value16) + COMMA + makeStr(value17) + COMMA + makeStr(value18) + COMMA + makeStr(value19) + COMMA + makeStr(value20) + COMMA + makeStr(value21) + COMMA + makeStr(value22) + COMMA + makeStr(value23) + COMMA + makeStr(value24) + END;
//				System.out.println("setInsertSql() : "+ insertSql);
	}
	
	public PersistentPeer getPersistentPeer()
	{
		return persistentPeer;/////////////////
	}
	public String getInsertSql()
	{
//		return e2h(insertSql);
		return (insertSql);// ѱ     . mysql ġ ѱۿɼ ΰͰ.
	}
	public String getDeleteSql()
	{
//		return e2h(deleteSql);
		return (deleteSql);
	}
	public String getUpdateSql()
	{
//		return e2h(updateSql);
		return (updateSql);
	}
	public String getSelectSql()
	{
//		return e2h(query);
		return (query);
	}
	
	public void setTerm(ParamMap paramMap)
	{
		tableV 			= null;
		name 			= (String)paramMap.get("NAME");
							p.r(this,"setTerm", name);
		budyid 				= (String)paramMap.get("BUDYID");
							p.r(this,"setTerm", phone);
		setQuery("name", name, "budyid",budyid);
		setDeleteSql("name",  name, "budyid",  budyid);
	}

	public void setPrintTerm(ParamMap paramMap)
	{
		tableV 			= null;
		name 			= (String)paramMap.get("NAME");
							p.r(this,"setTerm", name);
		budyid 				= (String)paramMap.get("BUDYID");
							p.r(this,"setTerm", budyid);
		selec 				= (String)paramMap.get("SELEC");
							p.r(this,"setTerm", selec);
		major 				= (String)paramMap.get("MAJOR");
							p.r(this,"setTerm", major);
		if (name != "")
			setQuery("name", name);
			
		else if (budyid != "")
			setQuery("budyid", budyid);
			
		else if (selec != "")
			setQuery("selec", selec);
			
		else if(major != "")
			setQuery("major", major);			
			
		else
			setQuery();
	}

	public void reset(ParamMap paramMap)
	{
		tableV 			= null;
		name 			= (String)paramMap.get("NAME");
							p.r(this,"reset", name);
		phone 				= (String)paramMap.get("PHONE");
							p.r(this,"reset", phone);
		mail 			= (String)paramMap.get("MAIL");
							p.r(this,"reset", mail);
		major 			= (String)paramMap.get("MAJOR");
							p.r(this,"reset", major);
		budyid 			= (String)paramMap.get("BUDYID");
							p.r(this,"reset", budyid);
		selec 			= (String)paramMap.get("SELEC");
							p.r(this,"reset", selec);
		na 			= (String)paramMap.get("NA");
		nb 			= (String)paramMap.get("NB");
		nc 			= (String)paramMap.get("NC");
		nd 			= (String)paramMap.get("ND");
		ne 			= (String)paramMap.get("NE");
		nf 			= (String)paramMap.get("NF");
		ng 			= (String)paramMap.get("NG");
		nh 			= (String)paramMap.get("NH");
		ni 			= (String)paramMap.get("NI");
		nj 			= (String)paramMap.get("NJ");
		nk 			= (String)paramMap.get("NK");
		nl 			= (String)paramMap.get("NL");
		nm 			= (String)paramMap.get("NM");
		nn 			= (String)paramMap.get("NN");
		no 			= (String)paramMap.get("NO");
		np 			= (String)paramMap.get("NP");
		
		calcOrder();	
		setQuery("name", name, "budyid",budyid);
		setDeleteSql("name",  name, "budyid",  budyid);
		setInsertSql( name, phone, mail, major, budyid, selec, na, nb, nc, nd, ne, nf, ng, nh, ni, nj, nk, nl, nm, nn, no, np, tot, price); 
	}
	
	void calcOrder()
	{
		int itot;
		int iprice;
		itot =  (na == "" ? 0 : Integer.parseInt(na)) + (nb == "" ? 0 : Integer.parseInt(nb)) + (nc == "" ? 0 : Integer.parseInt(nc)) + (nd == "" ? 0 : Integer.parseInt(nd)) + (ne == "" ? 0 : Integer.parseInt(ne)) + (nf == "" ? 0 : Integer.parseInt(nf)) + (ng == "" ? 0 : Integer.parseInt(ng)) + (nh == "" ? 0 : Integer.parseInt(nh)) + (ni == "" ? 0 : Integer.parseInt(ni)) + (nj == "" ? 0 : Integer.parseInt(nj)) + (nk == "" ? 0 : Integer.parseInt(nk)) + (nl == "" ? 0 : Integer.parseInt(nl)) + (nm == "" ? 0 : Integer.parseInt(nm)) + (nn == "" ? 0 : Integer.parseInt(nn)) + (no == "" ? 0 : Integer.parseInt(no)) + (np == "" ? 0 : Integer.parseInt(np)); 
//		itot =  Integer.parseInt(na) + Integer.parseInt(nb) + Integer.parseInt(nc) + Integer.parseInt(nd) + Integer.parseInt(ne) + Integer.parseInt(nf) + Integer.parseInt(ng) + Integer.parseInt(nh) + Integer.parseInt(ni) + Integer.parseInt(nj) + Integer.parseInt(nk) + Integer.parseInt(nl) + Integer.parseInt(nm) + Integer.parseInt(nn) + Integer.parseInt(no) + Integer.parseInt(np); 
		tot = String.valueOf (itot);
		iprice = itot * 4000;
		price = String.valueOf (iprice);
	}
	
	public boolean struct(Vector tableV)
	{
		p.r(this,"struct=tableV.size()",tableV.size());
		if(tableV.size() > 0)
		{
			String[] column = (String[])(tableV.elementAt(0));
			name = column[0];
			phone = column[1];
			mail = column[2];
			major = column[3];
			budyid = column[4];
			selec = column[5];
			na = column[6];
			nb = column[7];
			nc = column[8];
			nd = column[9];
			ne = column[10];
			nf = column[11];
			ng = column[12];
			nh = column[13];
			ni = column[14];
			nj = column[15];
			nk = column[16];
			nl = column[17];
			nm = column[18];
			nn = column[19];
			no = column[20];
			np = column[21];
			tot = column[22];
			price = column[23];
//			print();// ڵ Ʈ
			return true;
		}
		else
		{
			return false;
		}
	}

	public Vector reStruct(Vector tableV) // ʿ ׸   
	{
		p.r(this,"reStruct=tableV.size()",tableV.size());
		Vector newTableV = new Vector(0,1);
		String[] newColumn;
		String column[];
		for( int i = 0 ; i < tableV.size() ; i++ )
		{
//			System.out.println( "reStruct() : "  + i );
			column = (String[])(tableV.elementAt(i));
			newColumn = new String[24];
			newColumn[0] = h2e(column[0]);
			newColumn[1] = h2e(column[1]);
			newColumn[2] = h2e(column[2]);
			newColumn[3] = h2e(column[3]);
			newColumn[4] = h2e(column[4]);
			newColumn[5] = h2e(column[5]);
			newColumn[6] = h2e(column[6]);
			newColumn[7] = h2e(column[7]);
			newColumn[8] = h2e(column[8]);
			newColumn[9] = h2e(column[9]);
			newColumn[10] = h2e(column[10]);
			newColumn[11] = h2e(column[11]);
			newColumn[12] = h2e(column[12]);
			newColumn[13] = h2e(column[13]);
			newColumn[14] = h2e(column[14]);
			newColumn[15] = h2e(column[15]);
			newColumn[16] = h2e(column[16]);
			newColumn[17] = h2e(column[17]);
			newColumn[18] = h2e(column[18]);
			newColumn[19] = h2e(column[19]);
			newColumn[20] = h2e(column[20]);
			newColumn[21] = h2e(column[21]);
			newColumn[22] = h2e(column[22]);
			newColumn[23] = h2e(column[23]);
			newTableV.addElement(newColumn);
		}
		return newTableV;
	}
		
///////////////////////////////////////////////	
	void print(int no)
	{
/*
						name, phone, mail,
						 major, budyid, selec,
						 NA, NB, NC, ND,
						 NE, NF, NG, NH,
						 NI, NJ, NK, NL,
						 NM, NN, NO, NP
*/
/*
		System.out.println( "\n\n**********notepersistent : " + no + "******\n" );
		System.out.print( "name : " + name );
		System.out.print( "  |   ");
		System.out.print( "phone : " + phone );
		System.out.print( "  |   ");
		System.out.print( "mail : " + mail );
		System.out.print( "  |   ");
		System.out.print( "major : " + major );
		System.out.print( "  |   ");
		System.out.print( "budyid : " + budyid );
		System.out.print( "  |   ");
		System.out.println( "selec : " + selec );
		System.out.print( "  |   ");
		System.out.print( "NA : " + na );
		System.out.print( "  |   ");
		System.out.print( "NB : " + nb );
		System.out.print( "  |   ");
		System.out.print( "NC : " + nc );
		System.out.print( "  |   ");
		System.out.print( "ND : " + nd );
		System.out.print( "  |   ");
		System.out.println( "NE : " + ne );
		System.out.print( "  |   ");
		System.out.print( "NF : " + nf );
		System.out.print( "  |   ");
		System.out.print( "NG : " + ng );
		System.out.print( "  |   ");
		System.out.print( "NH : " + nh );
		System.out.print( "  |   ");
		System.out.print( "NI : " + ni );
		System.out.print( "  |   ");
		System.out.println( "NJ : " + nj );
		System.out.print( "  |   ");
		System.out.print( "NK : " + nk );
		System.out.print( "  |   ");
		System.out.print( "NL : " + nl );
		System.out.print( "  |   ");
		System.out.print( "NM : " + nm );
		System.out.print( "  |   ");
		System.out.print( "NN : " + nn );
		System.out.print( "  |   ");
		System.out.println( "NO : " + no );
		System.out.print( "  |   ");
		System.out.print( "NP : " + np );
		System.out.print( "  |   ");
		System.out.print( "tot : " + tot );
		System.out.print( "  |   ");
		System.out.print( "price : " + price );
		System.out.println( "\n************************************************************\n\n" );
*/
	}

	public void print(String all)
	{
		String[] record;
		for(int i = 0 ; i < tableV.size(); i++)
		{
			record = (String[])tableV.elementAt(i);
			System.out.println("------record no : " + i + " ----------------------------------");
			for(int j = 0 ; j < record.length ; j++)
			System.out.print("col[" + (j+1) + "] : " + record[j] + "     ");
		}
		System.out.println("----------------------------------------");
	}

	public void print()
	{
		print(0);
	}
	
	
	String makeStr(String str)
	{
		return "\'" + str + "\'";
	}
/*	
	void setColumn(String[] column)
	{
		for ( int no = 0 ; no < column.length ; no ++ )
		{
			noteInfo[no] = column[no];
		}
	}
*/
	public String getName()
	{
		return h2e(name);// DB ѱ    ȯŴ(mysql ѱ ⺻ ġ?)
	}
	public String getPhone()
	{
		return phone;
	}
	public String getMajor()
	{
		return major;
	}
	public String getMail()
	{
		return mail;
	}
	public String getBudyid()
	{
		return budyid;
	}
	public String getSelec()
	{
		return selec;
	}
	public String getNa()
	{
		return na;
	}
	public String getNb()
	{
		return nb;
	}
	public String getNc()
	{
		return nc;
	}
	public String getNd()
	{
		return nd;
	}
	public String getNe()
	{
		return ne;
	}
	public String getNf()
	{
		return nf;
	}
	public String getNg()
	{
		return ng;
	}
	public String getNh()
	{
		return nh;
	}
	public String getNi()
	{
		return ni;
	}
	public String getNj()
	{
		return nj;
	}
	public String getNk()
	{
		return nk;
	}
	public String getNl()
	{
		return nl;
	}
	public String getNm()
	{
		return nm;
	}
	public String getNn()
	{
		return nn;
	}
	public String getNo()
	{
		return no;
	}
	public String getNp()
	{
		return np;
	}
	public String getTot()
	{
		return tot;
	}
	public String getPrice()
	{
		return price ;
	}
	
	
} /* end class ConcretePersistent */
